scala.collection.immutable

# Stream

#### object Stream extends SeqFactory[Stream]

The object `Stream` provides helper functions to manipulate streams.

Source
  Stream.scala
Version

  1.1 08/08/03

Since

  2.8

Linear Supertypes
SeqFactory[Stream], TraversableFactory[Stream], GenericSeqCompanion[Stream], GenSeqFactory[Stream], GenTraversableFactory[Stream], GenericCompanion[Stream], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Stream
2. SeqFactory
3. TraversableFactory
4. GenericSeqCompanion
5. GenSeqFactory
6. GenTraversableFactory
7. GenericCompanion
8. AnyRef
9. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### type Coll = Stream[_]

   The underlying collection type with unknown element type

   The underlying collection type with unknown element type

   Definition Classes
     GenericCompanion

2. #### final class Cons [+A] extends Stream[A] with Serializable

   A lazy cons cell, from which streams are built.

3. #### class ConsWrapper [A] extends AnyRef

   A wrapper class that adds `#::` for cons and `#:::` for concat as operations to streams.

4. #### class GenericCanBuildFrom [A] extends CanBuildFrom[CC[_], A, CC[A]]

   A generic implementation of the `CanBuildFrom` trait, which forwards all calls to `apply(from)` to the `genericBuilder` method of collection `from`, and which forwards all calls of `apply()` to the `newBuilder` method of this factory.

5. #### class StreamBuilder [A] extends LazyBuilder[A, Stream[A]]

   A builder for streams

6. #### class StreamCanBuildFrom [A] extends GenericCanBuildFrom[A]

   The factory for streams.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### object #::

   An extractor that allows to pattern match streams with `#::`.

5. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

6. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

7. #### object Empty extends Stream[Nothing] with Serializable

8. #### lazy val ReusableCBF: GenericCanBuildFrom[Nothing]

   Definition Classes
     GenTraversableFactory

9. #### def apply[A](xs: A*): Stream[A]

   A stream consisting of given elements

   A stream consisting of given elements

   A

     the type of the collection's elements

   returns

     a new collection with elements `elems`

   Definition Classes
     Stream → GenericCompanion

10. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

11. #### implicit def canBuildFrom[A]: CanBuildFrom[Coll, A, Stream[A]]

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### def concat[A](xss: collection.Traversable[A]*): Stream[A]

    Concatenates all argument collections into a single collection.

    Concatenates all argument collections into a single collection.

    xss

      the collections that are to be concatenated.

    returns

      the concatenation of all the collections.

    Definition Classes
      GenTraversableFactory

14. #### object cons

    An alternative way of building and matching Streams using Stream.

15. #### implicit def consWrapper[A](stream: ⇒ Stream[A]): ConsWrapper[A]

    A wrapper method that adds `#::` for cons and `#::: for concat as operations to streams.`

16. #### def continually[A](elem: ⇒ A): Stream[A]

    Create an infinite stream containing the given element expression (which is computed for each occurrence).

    Create an infinite stream containing the given element expression (which is computed for each occurrence).

    elem

      the element composing the resulting stream

    returns

      the stream containing an infinite number of elem

17. #### def empty[A]: Stream[A]

    The empty stream

    The empty stream

    A

      the type of the collection's elements

    Definition Classes
      Stream → GenericCompanion

18. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

20. #### def fill[A](n: Int)(elem: ⇒ A): Stream[A]

    Produces a collection containing the results of some element computation a number of times.

    Produces a collection containing the results of some element computation a number of times.

    n

      the number of elements contained in the collection.

    elem

      the element computation

    returns

      A collection that contains the results of `n` evaluations of `elem`.

    Definition Classes
      Stream → GenTraversableFactory

21. #### def fill[A](n1: Int, n2: Int, n3: Int, n4: Int, n5: Int)(elem: ⇒ A): Stream[Stream[Stream[Stream[Stream[A]]]]]

    Produces a five-dimensional collection containing the results of some element computation a number of times.

    Produces a five-dimensional collection containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    n4

      the number of elements in the 4th dimension

    n5

      the number of elements in the 5th dimension

    elem

      the element computation

    returns

      A collection that contains the results of `n1 x n2 x n3 x n4 x n5` evaluations of `elem`.

    Definition Classes
      GenTraversableFactory

22. #### def fill[A](n1: Int, n2: Int, n3: Int, n4: Int)(elem: ⇒ A): Stream[Stream[Stream[Stream[A]]]]

    Produces a four-dimensional collection containing the results of some element computation a number of times.

    Produces a four-dimensional collection containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    n4

      the number of elements in the 4th dimension

    elem

      the element computation

    returns

      A collection that contains the results of `n1 x n2 x n3 x n4` evaluations of `elem`.

    Definition Classes
      GenTraversableFactory

23. #### def fill[A](n1: Int, n2: Int, n3: Int)(elem: ⇒ A): Stream[Stream[Stream[A]]]

    Produces a three-dimensional collection containing the results of some element computation a number of times.

    Produces a three-dimensional collection containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    elem

      the element computation

    returns

      A collection that contains the results of `n1 x n2 x n3` evaluations of `elem`.

    Definition Classes
      GenTraversableFactory

24. #### def fill[A](n1: Int, n2: Int)(elem: ⇒ A): Stream[Stream[A]]

    Produces a two-dimensional collection containing the results of some element computation a number of times.

    Produces a two-dimensional collection containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    elem

      the element computation

    returns

      A collection that contains the results of `n1 x n2` evaluations of `elem`.

    Definition Classes
      GenTraversableFactory

25. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

26. #### def from(start: Int): Stream[Int]

    Create an infinite stream starting at `start` and incrementing by `1`.

    Create an infinite stream starting at `start` and incrementing by `1`.

    start

      the start value of the stream

    returns

      the stream starting at value `start`.

27. #### def from(start: Int, step: Int): Stream[Int]

    Create an infinite stream starting at `start` and incrementing by step `step`.

    Create an infinite stream starting at `start` and incrementing by step `step`.

    start

      the start value of the stream

    step

      the increment value of the stream

    returns

      the stream starting at value `start`.

28. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

29. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

30. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

31. #### def iterate[A](start: A, len: Int)(f: (A) ⇒ A): Stream[A]

    Produces a collection containing repeated applications of a function to a start value.

    Produces a collection containing repeated applications of a function to a start value.

    start

      the start value of the collection

    len

      the number of elements contained inthe collection

    f

      the function that's repeatedly applied

    returns

      a collection with `len` values in the sequence `start, f(start), f(f(start)), ...`

    Definition Classes
      Stream → GenTraversableFactory

32. #### def iterate[A](start: A)(f: (A) ⇒ A): Stream[A]

    An infinite stream that repeatedly applies a given function to a start value.

    An infinite stream that repeatedly applies a given function to a start value.

    start

      the start value of the stream

    f

      the function that's repeatedly applied

    returns

      the stream returning the infinite sequence of values `start, f(start), f(f(start)), ...`

33. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

34. #### def newBuilder[A]: Builder[A, Stream[A]]

    Creates a new builder for a stream

    Creates a new builder for a stream

    A

      the type of the collection's elements

    Definition Classes
      Stream → GenericCompanion

35. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

36. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

37. #### def range[T](start: T, end: T, step: T)(implicit arg0: Integral[T]): Stream[T]

    Produces a collection containing equally spaced values in some integer interval.

    Produces a collection containing equally spaced values in some integer interval.

    start

      the start value of the collection

    end

      the end value of the collection (the first value NOT contained)

    step

      the difference between successive elements of the collection (must be positive or negative)

    returns

      a collection with values `start, start + step, ...` up to, but excluding `end`

    Definition Classes
      Stream → GenTraversableFactory

38. #### def range[T](start: T, end: T)(implicit arg0: Integral[T]): Stream[T]

    Produces a collection containing a sequence of increasing of integers.

    Produces a collection containing a sequence of increasing of integers.

    start

      the first element of the collection

    end

      the end value of the collection (the first value NOT contained)

    returns

      a collection with values `start, start + 1, ..., end - 1`

    Definition Classes
      GenTraversableFactory

39. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

40. #### def tabulate[A](n: Int)(f: (Int) ⇒ A): Stream[A]

    Produces a collection containing values of a given function over a range of integer values starting from 0.

    Produces a collection containing values of a given function over a range of integer values starting from 0.

    n

      The number of elements in the collection

    f

      The function computing element values

    returns

      A collection consisting of elements `f(0), ..., f(n -1)`

    Definition Classes
      Stream → GenTraversableFactory

41. #### def tabulate[A](n1: Int, n2: Int, n3: Int, n4: Int, n5: Int)(f: (Int, Int, Int, Int, Int) ⇒ A): Stream[Stream[Stream[Stream[Stream[A]]]]]

    Produces a five-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    Produces a five-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    n4

      the number of elements in the 4th dimension

    n5

      the number of elements in the 5th dimension

    f

      The function computing element values

    returns

      A collection consisting of elements `f(i1, i2, i3, i4, i5)` for `0 <= i1 < n1`, `0 <= i2 < n2`, `0 <= i3 < n3`, `0 <= i4 < n4`, and `0 <= i5 < n5`.

    Definition Classes
      GenTraversableFactory

42. #### def tabulate[A](n1: Int, n2: Int, n3: Int, n4: Int)(f: (Int, Int, Int, Int) ⇒ A): Stream[Stream[Stream[Stream[A]]]]

    Produces a four-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    Produces a four-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    n4

      the number of elements in the 4th dimension

    f

      The function computing element values

    returns

      A collection consisting of elements `f(i1, i2, i3, i4)` for `0 <= i1 < n1`, `0 <= i2 < n2`, `0 <= i3 < n3`, and `0 <= i4 < n4`.

    Definition Classes
      GenTraversableFactory

43. #### def tabulate[A](n1: Int, n2: Int, n3: Int)(f: (Int, Int, Int) ⇒ A): Stream[Stream[Stream[A]]]

    Produces a three-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    Produces a three-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3nd dimension

    f

      The function computing element values

    returns

      A collection consisting of elements `f(i1, i2, i3)` for `0 <= i1 < n1`, `0 <= i2 < n2`, and `0 <= i3 < n3`.

    Definition Classes
      GenTraversableFactory

44. #### def tabulate[A](n1: Int, n2: Int)(f: (Int, Int) ⇒ A): Stream[Stream[A]]

    Produces a two-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    Produces a two-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    f

      The function computing element values

    returns

      A collection consisting of elements `f(i1, i2)` for `0 <= i1 < n1` and `0 <= i2 < n2`.

    Definition Classes
      GenTraversableFactory

45. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

46. #### def unapplySeq[A](x: Stream[A]): Some[Stream[A]]

    This method is called in a pattern match { case Seq(.

    This method is called in a pattern match { case Seq(...) => }.

    x

      the selector value

    returns

      sequence wrapped in an option, if this is a Seq, otherwise none

    Definition Classes
      SeqFactory

47. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

48. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

49. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

### Inherited from SeqFactory[Stream]

### Inherited from TraversableFactory[Stream]

### Inherited from GenericSeqCompanion[Stream]

### Inherited from GenSeqFactory[Stream]

### Inherited from GenTraversableFactory[Stream]

### Inherited from GenericCompanion[Stream]

### Inherited from AnyRef

### Inherited from Any

### Ungrouped